from strictyaml.ruamel.tokens import *
from strictyaml.ruamel.events import *
from _typeshed import Incomplete
from strictyaml.ruamel.error import MarkedYAMLError
from typing import Any

class ParserError(MarkedYAMLError): ...

class Parser:
    DEFAULT_TAGS: Incomplete
    loader: Incomplete
    def __init__(self, loader: Any) -> None: ...
    current_event: Incomplete
    tag_handles: Incomplete
    states: Incomplete
    marks: Incomplete
    state: Incomplete
    def reset_parser(self) -> None: ...
    def dispose(self) -> None: ...
    @property
    def scanner(self) -> Any: ...
    @property
    def resolver(self) -> Any: ...
    def check_event(self, *choices: Any) -> bool: ...
    def peek_event(self) -> Any: ...
    def get_event(self) -> Any: ...
    def parse_stream_start(self) -> Any: ...
    def parse_implicit_document_start(self) -> Any: ...
    def parse_document_start(self) -> Any: ...
    def parse_document_end(self) -> Any: ...
    def parse_document_content(self) -> Any: ...
    def process_directives(self) -> Any: ...
    def parse_block_node(self) -> Any: ...
    def parse_flow_node(self) -> Any: ...
    def parse_block_node_or_indentless_sequence(self) -> Any: ...
    def transform_tag(self, handle: Any, suffix: Any) -> Any: ...
    def parse_node(self, block: bool = ..., indentless_sequence: bool = ...) -> Any: ...
    def parse_block_sequence_first_entry(self) -> Any: ...
    def parse_block_sequence_entry(self) -> Any: ...
    def parse_indentless_sequence_entry(self) -> Any: ...
    def parse_block_mapping_first_key(self) -> Any: ...
    def parse_block_mapping_key(self) -> Any: ...
    def parse_block_mapping_value(self) -> Any: ...
    def parse_flow_sequence_first_entry(self) -> Any: ...
    def parse_flow_sequence_entry(self, first: bool = ...) -> Any: ...
    def parse_flow_sequence_entry_mapping_key(self) -> Any: ...
    def parse_flow_sequence_entry_mapping_value(self) -> Any: ...
    def parse_flow_sequence_entry_mapping_end(self) -> Any: ...
    def parse_flow_mapping_first_key(self) -> Any: ...
    def parse_flow_mapping_key(self, first: Any = ...) -> Any: ...
    def parse_flow_mapping_value(self) -> Any: ...
    def parse_flow_mapping_empty_value(self) -> Any: ...
    def process_empty_scalar(self, mark: Any, comment: Any = ...) -> Any: ...

class RoundTripParser(Parser):
    def transform_tag(self, handle: Any, suffix: Any) -> Any: ...
